﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CommonLib;
using System.IO;

namespace MainServer
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("current domain: {0}", AppDomain.CurrentDomain.FriendlyName + Environment.NewLine);

            Console.WriteLine("input two data to calc: ");
            Console.Write("a: ");
            int a = Convert.ToInt32(Console.ReadLine());
            Console.Write("b: ");
            int b = Convert.ToInt32(Console.ReadLine());

            AppDomain ad_Calc = AppDomain.CreateDomain("domin #calc");
            ICalculater calc = (ICalculater)ad_Calc.CreateInstanceAndUnwrap("Module1", "Module1.Calculater");
            calc.Calc(a, b);

            string cmd;
            while ((cmd = Console.ReadLine()).ToLower() != "quit")
            {
                switch (cmd.ToLower())
                {
                    case "del_calc":
                        TryDelete("Module1.dll");
                        Console.WriteLine();
                        break;
                    case "unload_calc":
                        UnloadDomain(ad_Calc);
                        Console.WriteLine();
                        break;
                    case "reload_and_run_calc":
                        AppDomain domainNew;
                        if (ReloadDomain(out domainNew))
                        {
                            ICalculater calcNew = (ICalculater)domainNew.CreateInstanceAndUnwrap("Module1", "Module1.Calculater");
                            calcNew.Calc(a, b);
                        }
                        Console.WriteLine();
                        break;
                }
            }
        }

        static void TryDelete(string fileName)
        {
            try
            {
                string fullName = AppDomain.CurrentDomain.BaseDirectory + fileName;
                File.Delete(fileName);
                Console.WriteLine("delete file: {0} success.", fileName);
            }
            catch (Exception ex)
            {
                Console.WriteLine("delete file: {0} failed. - {1}", fileName, ex.Message);
            }
        }

        static void UnloadDomain(AppDomain appDomain)
        {
            if (appDomain == null)
                return;

            string friendlyname = appDomain.FriendlyName;
            AppDomain.Unload(appDomain);
            Console.WriteLine("appDomain {0} unloaded", friendlyname);
        }

        static bool ReloadDomain(out AppDomain appDomain)
        {
            try
            {
                appDomain = AppDomain.CreateDomain("domin reload #calc");
                Console.WriteLine("domain reloaded, name: domin reload #calc");
                return true;
            }
            catch
            {
                appDomain = null;
                return false;
            }
        }
    }
}
